collaborators = 'Your collaborators here'

# Answer True or False for each part of problem 1.

answer_for_problem_1_part_a = True
# This also correctly moves the left child into the node's place

answer_for_problem_1_part_b = False
# This may cause violation of the BST property

answer_for_problem_1_part_c = True
# This node cannot be None, since the right node exists

answer_for_problem_1_part_d = True
# Everything is symmetric.

answer_for_problem_1_part_e = False
# Replacing next with his right child works, but we forgot to update val and count

answer_for_problem_1_part_f = False
# next.val will change if we recursively delete, causing our updated node.val to be wrong

answer_for_problem_1_part_g = True
# At this point, this function must turn True

# On problem 2, your answer to part a) should be a boolean, your to part b)
# should be an integer, and your answer to part c) should be a string.
answer_for_problem_2_part_a = True
answer_for_problem_2_part_b = 2
answer_for_problem_2_part_c = """
Suppose some data structure supported insert, get_min, and delete of arbitrary ordered values, in o(log n).
Then, the above algorithm would run in o(n log n) and also correctly sort.  This is a contradiction.
"""

# Enter your answer to problem 3 here.
answer_for_problem_3 = '''
    Sort all arrival and departure times together in an array A, putting a
    pointer indicating whether the time in the sorted array is an arrival or
    a departure time of a person in the party.
    Let T be an augmented BST, where at each node X we keep the number of
    elements of the subtree rooted at X. Initially, T is empty. Each node will
    be a person that went to the party, where the value of the key is their
    departure time. Hence, T will be a BST in which each node is put with value
    being its departure time and each node has the extra information described
    above. (we are doing this so that we can compute the rank in O(log n)).
    Let ANS be the total number of follows we will have in the end. Initially,
    ANS = 0.
    Loop through the entries of A as follows: (i ranging from 1 to 2n)
        If A[i] is an arrival time, then insert the corresponding element E in T and check its rank in T. Let K_e be the rank of E in T. Then, ANS += K_e - 1. (because we don't follow ourselves on twitter :-p) 
        If A[i] is a departure time, remove element E from T.
    
    Correctness: when we insert E in T, we have that all elements in T are the
    people who were at the party when E arrived, since we are inserting E by 
    arrival time. Moreover, T does not contain people who left the party by the 
    time we insert E, since they will be removed from T as they leave. Hence, 
    K_e - 1 is exactly the number of people that arrived at the party by the 
    time the E arrived and that will leave the party before E leaves, since the 
    tree is constructed by departure time. Hence, ANS will be the number that we 
    want in the end.
    
    Runtime analysis: it takes O(n log n) to sort the array A. Then, to insert/
    delete/compute the rank in T, each of these operations take O(log n). Since 
    we perform operations in T 2n times, the total time of going thorugh and 
    performing operations in the tree is O(n log n).
    This gives a total running time of O(n log n).
'''

# -- Problem 4 code begins here. You need to finish the last function. --

# Rotates the polyomino 90 degrees counterclockwise. Returns a new list.
def rotate(polyomino):
  return [(-y, x) for (x, y) in polyomino]

# Translates the polyomino by the offset. Returns a new list.
def translate(polyomino, offset):
  return [(x + offset[0], y + offset[1]) for (x, y) in polyomino]

# Checks if two polyominoes are equivalent under rotation and translation. Runs
# in linear time in the size of the two polyominoes.
def compare(poly1, poly2):
  if len(poly1) != len(poly2):
    return False

  # Translates a polyomino so that it just touches the x and y axes. Returns the
  # set of squares in the translated shape.
  def get_canonical_set(polyomino):
    offset = (-min(x for (x, y) in polyomino), -min(y for (x, y) in polyomino))
    return set(translate(polyomino, offset))

  poly1_set = get_canonical_set(poly1)
  for i in range(4):
    poly2_set = get_canonical_set(poly2)
    if poly1_set == poly2_set:
      return True
    poly2 = rotate(poly2)

  return False


def get_canonical_frozenset(polyomino):
  offset = (-min(x for (x, y) in polyomino), -min(y for (x, y) in polyomino))
  return frozenset(translate(polyomino, offset))

def add_protein_to_dictionary(protein, d):
  d[get_canonical_frozenset(protein)] = True

# Fill in the body of this function for Problem 4.
def num_proteins_in_common(protein_list1, protein_list2):
  proteindict = {}
  count = 0

  for protein in protein_list1:
    proteindict[get_canonical_frozenset(protein)] = 1

  for protein in protein_list2:
    for i in range(4):
      if get_canonical_frozenset(protein) in proteindict:
        count += 1
        break
      protein = rotate(protein)

  return common_count


